﻿package  
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.filters.BlurFilter;
	import hype.extended.behavior.FixedVibration;
	import hype.extended.behavior.VariableVibration;
	import hype.extended.rhythm.FilterCanvasRhythm;
	import hype.extended.trigger.ExitShapeTrigger;
	import hype.framework.core.ObjectPool;
	import hype.framework.core.TimeType;
	import hype.framework.display.BitmapCanvas;
	


	/**
	 * A tutorial to introduce HYPE. A visual framework
	 * by Branden Hall and Joshua David for creating 
	 * generative / iterative designs with code.
	 * 
	 * @author Anton Mills
	 * @version 06/02/2011
	 */
	public class Main extends MovieClip 
	{
		// private properties
	private var bitmapCanvas:BitmapCanvas;
	private var clipContainer:Sprite;
	private var objectPool:ObjectPool;
	
	
	
	/**
	 * constructor
	 */
	public function Main()
	{
		// inits the Hype framework
		initHype();
		
		objectPool.requestAll();
	}
	
	
	
	/**
	 * initiation of the Hype members we will be using and configuration prior
	 * to running the animation
	 */
	private function initHype():void
	{
		// the clipContainer is used as a parent for all of our objects
		clipContainer = new Sprite();
		addChild(clipContainer);
	
		// think of the BitmapCanvas as an empty space we will 'paint'
		// every frame with new image data
		bitmapCanvas = new BitmapCanvas(stage.stageWidth, stage.stageHeight);
		//bitmapCanvas.startCapture(clipContainer, true);
		addChild(bitmapCanvas);
	
		// create a collection of 10 objects and store them in an ObjectPool
		// for use in the animation
		objectPool = new ObjectPool(circleShape, 100);
		
		// each time we request a new shape from the pool
		// it will perform the following
		objectPool.onRequestObject = function(clip:MovieClip):void
		{
			clip.x = Math.random() * stage.stageWidth;
			clip.y = Math.random() * stage.stageHeight;
			
			clipContainer.addChild(clip);
		}
	}
	}
}